# Generated by Django 3.0.2 on 2020-05-25 13:25

import django.contrib.auth.models
import django.contrib.postgres.fields.jsonb
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0011_update_proxy_permissions'),
    ]

    operations = [
        migrations.CreateModel(
            name='Country',
            fields=[
                ('iso_code', models.CharField(max_length=2, primary_key=True, serialize=False, verbose_name='ISO code')),
                ('name', models.TextField(verbose_name='name')),
            ],
            options={
                'verbose_name': 'country',
                'verbose_name_plural': 'countries',
                'db_table': 'country',
                'ordering': ('iso_code',),
            },
        ),
        migrations.CreateModel(
            name='Language',
            fields=[
                ('iso_code', models.CharField(max_length=2, primary_key=True, serialize=False, verbose_name='ISO code')),
                ('name', models.TextField(verbose_name='name')),
            ],
            options={
                'verbose_name': 'language',
                'verbose_name_plural': 'languages',
                'db_table': 'language',
                'ordering': ('iso_code',),
            },
        ),
        migrations.CreateModel(
            name='Region',
            fields=[
                ('iso_code', models.CharField(max_length=2, primary_key=True, serialize=False, verbose_name='ISO code')),
                ('name', models.TextField(verbose_name='name')),
                ('country', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='regions', to='authentication.Country', verbose_name='country')),
                ('default_language', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='regions_as_default', to='authentication.Language', verbose_name='default language')),
                ('languages', models.ManyToManyField(db_table='region_languages', to='authentication.Language', verbose_name='languages')),
            ],
            options={
                'verbose_name': 'region',
                'verbose_name_plural': 'regions',
                'db_table': 'region',
                'ordering': ('iso_code',),
            },
        ),
        migrations.AddField(
            model_name='country',
            name='default_language',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='countries_as_default', to='authentication.Language', verbose_name='default language'),
        ),
        migrations.AddField(
            model_name='country',
            name='languages',
            field=models.ManyToManyField(db_table='country_languages', to='authentication.Language', verbose_name='languages'),
        ),
        migrations.CreateModel(
            name='User',
            fields=[
                ('password', models.CharField(max_length=128, verbose_name='password')),
                ('last_login', models.DateTimeField(blank=True, null=True, verbose_name='last login')),
                ('is_superuser', models.BooleanField(default=False, help_text='Designates that this user has all permissions without explicitly assigning them.', verbose_name='superuser status')),
                ('email', models.EmailField(blank=True, max_length=254, verbose_name='email address')),
                ('is_staff', models.BooleanField(default=False, help_text='Designates whether the user can log into this admin site.', verbose_name='staff status')),
                ('is_active', models.BooleanField(default=True, help_text='Designates whether this user should be treated as active. Unselect this instead of deleting accounts.', verbose_name='active')),
                ('date_joined', models.DateTimeField(default=django.utils.timezone.now, verbose_name='date joined')),
                ('id', models.CharField(blank=True, max_length=255, null=True, verbose_name='identifier')),
                ('username', models.CharField(error_messages={'unique': 'A user with that username already exists.'}, help_text='Required. 255 characters or fewer. Letters, digits and @/./+/-/_ only.', max_length=255, primary_key=True, serialize=False, verbose_name='username')),
                ('first_name', models.CharField(blank=True, max_length=255, null=True, verbose_name='first name')),
                ('last_name', models.CharField(blank=True, max_length=255, null=True, verbose_name='last name')),
                ('name', models.CharField(blank=True, max_length=255, null=True, verbose_name='full name')),
                ('date_last_connection', models.DateTimeField(default=django.utils.timezone.now, verbose_name='date of last connection')),
                ('picture', models.ImageField(blank=True, null=True, upload_to='user/picture/%Y/%m/%d/', verbose_name='picture')),
                ('additional_data', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                ('is_first_connection', models.BooleanField(default=True, verbose_name='is first connection')),
                ('iacs_consent', models.BooleanField(default=False, verbose_name='IACS consent')),
                ('groups', models.ManyToManyField(blank=True, help_text='The groups this user belongs to. A user will get all permissions granted to each of their groups.', related_name='user_set', related_query_name='user', to='auth.Group', verbose_name='groups')),
                ('preferred_language', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, related_name='user_as_preferred_language', to='authentication.Language', verbose_name='preferred language')),
                ('region', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='authentication.Region', verbose_name='region')),
                ('user_permissions', models.ManyToManyField(blank=True, help_text='Specific permissions for this user.', related_name='user_set', related_query_name='user', to='auth.Permission', verbose_name='user permissions')),
            ],
            options={
                'verbose_name': 'User',
                'verbose_name_plural': 'Users',
                'db_table': 'user',
                'ordering': ('username',),
            },
            managers=[
                ('objects', django.contrib.auth.models.UserManager()),
            ],
        ),
    ]
